/**
 * Sample applet that creates a circle of colors
 */

import java.applet.*;
import java.awt.*;
import java.lang.Math;

/**
 * @author t a y l o r@msoe.edu
 *
 * Lifted from: http://www.dgp.toronto.edu/~mjmcguff/learn/java/
 */
public class DrawColorApplet extends Applet {

    private int width;
    private int height;
    private int numColors = 25;
    private Color[] spectrum;
    
    public void init() {
        width = getSize().width;
        height = getSize().height;
        setBackground(Color.black);
        
        spectrum = new Color[numColors];
        
        for(int i=0; i<numColors; ++i) {
            spectrum[i] = new Color(Color.HSBtoRGB(i/(float)numColors,1,1));
        }
    }
    
    public void paint(Graphics g) {
        int radius = width / 3;
        for(int i=0; i<spectrum.length; ++i) {
            double angle = 2 * Math.PI * i/(double)numColors;
            int x = (int)(radius*Math.cos(angle));
            int y = (int)(radius*Math.sin(angle));
            
            g.setColor(spectrum[i]);
            g.drawString("Color", width/2+x, height/2+y);
        }
    }
    
}
