/**
 * Sample applet that draws a block and allows it to be dragged by
 * the mouse.
 */

import java.applet.*;
import java.awt.*;
import java.awt.event.*;

/**
 * @author t a y l o r@msoe.edu
 *
 * Lifted from: http://www.dgp.toronto.edu/~mjmcguff/learn/java/
 */
public class MouseApplet extends Applet
	implements MouseListener, MouseMotionListener {
    
    private int width;
    private int height;
    private int x; // Box coords
    private int y;
    private int mx; // Mouse coords
    private int my;
    
    private boolean isMouseDraggingBox = false;
    
    public void init() {
        width = getSize().width;
        height = getSize().height;
        setBackground(Color.black);
        
        x = width/2 - 20;
        y = height/2 -20;
        
        addMouseListener(this);
        addMouseMotionListener(this);
    }
    
    public void mouseEntered( MouseEvent e ) {}
    public void mouseExited( MouseEvent e ) {}
    public void mouseClicked( MouseEvent e ) {}
    public void mousePressed( MouseEvent e ) {
        mx = e.getX();
        my = e.getY();
        if(x<mx && mx<x+40 && y<my && my<y+40) {
            isMouseDraggingBox = true;
        }
        e.consume();
    }
    
    public void mouseReleased(MouseEvent e) {
        isMouseDraggingBox = false;
        e.consume();
    }
    public void mouseMoved(MouseEvent e) {}
    public void mouseDragged(MouseEvent e) {
        int new_mx = e.getX();
        int new_my = e.getY();
        
        x += new_mx - mx;
        y += new_my - my;
        
        mx = new_mx;
        my = new_my;
        
        repaint();
        e.consume();
    }
    
    public void paint(Graphics g) {
        g.setColor(Color.gray);
        g.fillRect(x, y, 40, 40);
    }
    
}
