/**
 * Sample applet that draws a block and allows it to be dragged by
 * the mouse.
 */

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

/**
 * @author t a y l o r@msoe.edu
 *
 * Lifted from: http://www.dgp.toronto.edu/~mjmcguff/learn/java/
 * Modified to make use of a LinkedList
 */
public class Snake extends Applet
   implements MouseListener, MouseMotionListener {

   int width, height;

   // We will talk more about LinkedList in CS2851
   LinkedList listOfPositions;

   public void init() {
      width = getSize().width;
      height = getSize().height;
      setBackground( Color.black );

      listOfPositions = new LinkedList();

      addMouseListener( this );
      addMouseMotionListener( this );
   }

   public void mouseEntered( MouseEvent e ) { }
   public void mouseExited( MouseEvent e ) { }
   public void mouseClicked( MouseEvent e ) { }
   public void mousePressed( MouseEvent e ) { }
   public void mouseReleased( MouseEvent e ) { }
   public void mouseMoved( MouseEvent e ) {

      if ( listOfPositions.size() >= 50 ) {
         // delete the first element in the list
         listOfPositions.removeFirst();
      }

      // add the new position to the end of the list
      listOfPositions.add( new Point( e.getX(), e.getY() ) );

      repaint(); // tells the Component to repaint itself
      e.consume();
   }
   public void mouseDragged( MouseEvent e ) { }

   public void paint( Graphics g ) {
      g.setColor( Color.white );
      ListIterator itr = listOfPositions.listIterator(0);
      Point A;
      if(itr.hasNext()) {
          A = (Point)(itr.next());
          while ( itr.hasNext() ) {
              Point B = (Point)(itr.next());
              g.drawLine( A.x, A.y, B.x, B.y );
              A = B;
          }
      }
   }
}
